<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaBase\ViewHelpers\BackendLayout;

/**
 * @package     imia_base
 * @subpackage  ViewHelpers
 * @author      David Frerich <d.frerich@imia.de>
 */
class ContainerViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper
{
    /**
     * @param integer $pageUid
     * @param string $label
     * @return string
     */
    public function render($pageUid, $label = 'Seiteneigenschaften')
    {
        $contents = $this->renderChildren();

        $output = '
            <style type="text/css">
                .t3-pagesettings th {
                    text-align: left !important;
                }
                .t3-pagesettings .t3-page-ce-wrapper th,
                .t3-pagesettings .t3-page-ce-wrapper td {    
                    padding: 3px 0 6px;
                    vertical-align: top;
                }
                .t3-pagesettings .t3-page-ce-wrapper tr:last-child th,
                .t3-pagesettings .t3-page-ce-wrapper tr:last-child td {
                    padding-bottom: 0;
                }
                .t3-pagesettings .t3-page-ce-wrapper th {    
                    line-height: 24px;
                    padding-right: 12px;
                    padding-left: 6px;
                    padding-top: 0;
                    text-align: right;
                    white-space: nowrap;
                }
                .t3-pagesettings .t3-page-ce-wrapper th a {
                    visibility: hidden;
                }
                .t3-pagesettings .t3-page-ce-wrapper th:hover a {
                    visibility: visible;
                }
                .t3-pagesettings table {
                    table-layout: fixed;
                    width: 100%;
                }
                .t3-pagesettings ul {
                    padding-left: 15px;
                    margin: 0;
                }
                .t3-pagesettings .property-contents {
                    width: 100%;
                    display: block;
                }
                .t3-pagesettings .property-contents figure,
                .t3-pagesettings .property-contents figure > img {
                    max-width: 100% !important;
                    width: auto !important;
                    height: auto !important;
                }
            </style>
            <div class="t3-gridContainer t3-pagesettings">
                <table cellspacing="0" cellpadding="0" border="0" width="100%" height="100%" class="t3-page-columns t3-gridTable">
                    <tbody>
                        <tr>
                            <td valign="top" class="t3-gridCell t3-page-column t3-page-column-0 t3-gridCell-width3" colspan="3">
                                <div class="t3-page-colHeader t3-row-header">
                                    <div class="t3-page-colHeader-icons">
                                        <a onclick="window.location.href=\'../../../alt_doc.php?returnUrl=%2Ftypo3%2Fsysext%2Fcms%2Flayout%2Fdb_layout.php%3Fid%3D' . $pageUid . '&amp;edit[pages][' . $pageUid . ']=edit\'; return false;" href="#">
                                            <span class="t3-icon t3-icon-actions t3-icon-actions-document t3-icon-document-open">&nbsp;</span>
                                        </a>
                                    </div>
                
                                    <div class="t3-page-colHeader-label">' . $label . '</div>
                                </div>
                                <div class="t3-page-ce-wrapper">
                                    <div class="t3-page-ce">
                                        <br>
                                        ' . $contents . '
                                        <br>
                                    </div>
                                </div>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>';

        return $output;
    }
}