<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaBase\ViewHelpers\BackendLayout;

/**
 * @package     imia_base
 * @subpackage  ViewHelpers
 * @author      David Frerich <d.frerich@imia.de>
 */
class PropertyViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper
{
    /**
     * @param integer $pageUid
     * @param string $name
     * @param string $label
     * @return string
     */
    public function render($pageUid, $name, $label = null)
    {
        $contents = $this->renderChildren();
        if (!$label) {
            $label = $name;
        }

        $output = '
            <tr>
                <th>
                    ' . $label . '

                    <a style="position: relative; top: -2px" onclick="window.location.href=\'../../../alt_doc.php?returnUrl=%2Ftypo3%2Fsysext%2Fcms%2Flayout%2Fdb_layout.php%3Fid%3D' . $pageUid . '&amp;edit[pages][' . $pageUid . ']=edit&amp;columnsOnly=' . $name . '\'; return false;" href="#">
                        <span class="t3-icon t3-icon-actions t3-icon-actions-document t3-icon-document-open">&nbsp;</span>
                    </a>
                </th>
                <td>
                    <a onclick="window.location.href=\'../../../alt_doc.php?returnUrl=%2Ftypo3%2Fsysext%2Fcms%2Flayout%2Fdb_layout.php%3Fid%3D' . $pageUid . '&amp;edit[pages][' . $pageUid . ']=edit&amp;columnsOnly=' . $name . '\'; return false;" href="#" class="property-contents">
                        ' . $contents . '
                    </a>
                </td>
            </tr>';

        return $output;
    }
}