<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2014 David Frerich (dfrerich@cdfre.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaBase\Xclass\Fluidpages\Override\Backend\View;

use IMIA\ImiaBase\Xclass\Backend\View\PageLayoutView as DefaultPageLayoutView;

/**
 * @package     imia_base
 * @subpackage  Xclass
 * @author      David Frerich <d.frerich@imia.de>
 */
class PageLayoutView extends \FluidTYPO3\Fluidpages\Override\Backend\View\PageLayoutView
{
    /**
     * @param $id
     * @return string
     */
    public function getTable_tt_content($id)
    {
        return DefaultPageLayoutView::getTable_tt_content_add($this, $id, parent::getTable_tt_content($id));
	}

    /**
     * @param array $row
     * @param bool $isRTE
     * @return string
     */
    public function tt_content_drawItem($row, $isRTE = FALSE)
    {
        $out = parent::tt_content_drawItem($row, $isRTE);
        DefaultPageLayoutView::tt_content_drawItem_add($this, $this->id, $row, $isRTE, $out);

        return $out;
    }

    /**
     * @param array $row
     * @return string
     */
    protected function tt_content_drawFooter(array $row)
    {
        return DefaultPageLayoutView::tt_content_drawFooter_new($this, $row);
    }

    /**
     * @param array $row
     * @param integer $space
     * @param boolean $disableMoveAndNewButtons
     * @param boolean $langMode
     * @param boolean $dragDropEnabled
     * @return string
     */
    public function tt_content_drawHeader($row, $space = 0, $disableMoveAndNewButtons = FALSE, $langMode = FALSE, $dragDropEnabled = FALSE)
    {
        if (!$this->languageIconTitles) {
            $this->initializeLanguages();
        }

        return parent::tt_content_drawHeader($row, $space, $disableMoveAndNewButtons, !$this->tt_contentConfig['languageMode'], $dragDropEnabled);
    }
}