<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 IMIA net based solutions (d.frerich@imia.de)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

namespace IMIA\ImiaBase\Xclass\Vhs\ViewHelpers\Content\Resources;

use TYPO3\CMS\Core\Utility\ArrayUtility;
use FluidTYPO3\Vhs\Utility\ResourceUtility;

/**
 * @package     imia_base
 * @subpackage  ViewHelpers
 * @author      David Frerich <d.frerich@imia.de>
 */
class FalViewHelper extends \FluidTYPO3\Vhs\ViewHelpers\Content\Resources\FalViewHelper
{
    /**
     * @param mixed $identity
     * @return mixed
     */
    public function getResource($identity)
    {
        $fileReference = $this->resourceFactory->getFileReferenceObject(intval($identity));

        try {
            $file = $fileReference->getOriginalFile();
            $fileProperties = ResourceUtility::getFileArray($file);
        } catch(\Exception $e) {
            $fileProperties = array(
                'missing' => '1',
            );
        }

        $fileReferenceProperties = $fileReference->getProperties();
        ArrayUtility::mergeRecursiveWithOverrule($fileProperties, $fileReferenceProperties, TRUE, FALSE, FALSE);

        return $fileProperties;
    }
}
