<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013-2014 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

if (!defined ('TYPO3_MODE')) {
    die ('Access denied.');
}

\IMIA\ImiaComposer\Utility\Composer::fetch();
$GLOBALS['TYPO3_CONF_VARS']['FE']['addRootLineFields'] .= ', module';

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTypoScript($_EXTKEY, 'setup',
    '<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/Configuration/TypoScript/setup.ts">', true);

$extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf'][$_EXTKEY]);
if ($extConf['bootstrapVisibility']) {
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTypoScript($_EXTKEY, 'setup',
        '<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/Configuration/TypoScript/bootstrapVisibility.ts">', true);
}

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPItoST43($_EXTKEY,
    'Classes/Plugin/TemplavoilaContentSlide.php', 'TemplavoilaContentSlide', '', 1);

if (getenv('APPLICATION_ENV') == 'dev') {
    // disable TypoScript Cache
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addUserTSConfig(
        'admPanel.override.tsdebug.forceTemplateParsing = 1');
}

if (!function_exists('user_isInMenuFolder')) {
    function user_isInMenuFolder()
    {
        $inMenuFolder = false;
        if ($GLOBALS['TSFE'] && $GLOBALS['TSFE']->tmpl && is_array($GLOBALS['TSFE']->tmpl->rootLine)) {
            foreach ($GLOBALS['TSFE']->tmpl->rootLine as $page) {
                if ($page['module'] == 'menu') {
                    $inMenuFolder = true;
                    break;
                }
            }
        }

        return $inMenuFolder;
    }
}

/* Hook */
$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['tslib/class.tslib_fe.php']['configArrayPostProc'][$_EXTKEY] =
    'IMIA\ImiaBase\Hook\TypoScriptFrontendController->configArrayPostProc';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['tslib/class.tslib_fe.php']['tslib_fe-PostProc'][$_EXTKEY] =
    'IMIA\ImiaBase\Hook\TypoScriptFrontendController->constructPostProc';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_page.php']['getRecordOverlay'][$_EXTKEY] =
    'IMIA\ImiaBase\Hook\PageRepositoryGetRecordOverlayHook';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['t3lib/class.t3lib_pagerenderer.php']['render-postProcess'][$_EXTKEY] =
    'IMIA\ImiaBase\Hook\PageRenderer->renderPostProcess';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['templavoila']['db_new_content_el']['wizardItemsHook'][$_EXTKEY] =
    'IMIA\ImiaBase\Hook\TemplavoilaNewContentElement';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['tslib/class.tslib_content.php']['getData'][$_EXTKEY] =
    'IMIA\ImiaBase\Hook\ContentObjectRenderer';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['cms/layout/class.tx_cms_layout.php']['tt_content_drawItem'][$_EXTKEY] =
    'IMIA\ImiaBase\Hook\PageLayoutViewDrawItemHook';

$GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['GLOBAL']['extTablesInclusion-PostProcessing'][$_EXTKEY] =
    'IMIA\ImiaBase\Hook\TableConfigurationPostProcessing';

/* Xclass */
if (\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded('fluidpages') 
  && (float)\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getExtensionVersion('fluidpages') <= 3.0) {
    $GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Fluidpages\Override\Backend\View\PageLayoutView'] = array(
        'className' => 'IMIA\ImiaBase\Xclass\Fluidpages\Override\Backend\View\PageLayoutView',
    );
} else {
    $GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\View\PageLayoutView'] = array(
        'className' => 'IMIA\ImiaBase\Xclass\Backend\View\PageLayoutView',
    );
}
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Backend\View\LogoView'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Backend\View\LogoView',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\TypoScript\TemplateService'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Core\TypoScript\TemplateService',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\TypoScript\ExtendedTemplateService'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Core\TypoScript\ExtendedTemplateService',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\TypoScript\ConfigurationForm'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Core\TypoScript\ConfigurationForm',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Frontend\ContentObject\ShockwaveFlashObjectContentObject'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Frontend\ContentObject\ShockwaveFlashObjectContentObject',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Frontend\ContentObject\ContentObjectRenderer',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Flux\Form\Field\Inline\Fal'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Flux\Form\Field\Inline\Fal',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Flux\Form\Field\MultiRelation'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Flux\Form\Field\MultiRelation',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Flux\Form\Field\Relation'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Flux\Form\Field\Relation',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Flux\Form\Wizard\Suggest'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Flux\Form\Wizard\Suggest',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Flux\ViewHelpers\Field\Inline\FalViewHelper'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Flux\ViewHelpers\Field\Inline\FalViewHelper',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Flux\ViewHelpers\Be\ContentElementViewHelper'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Flux\ViewHelpers\Be\ContentElementViewHelper',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Flux\ViewHelpers\Wizard\SuggestViewHelper'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Flux\ViewHelpers\Wizard\SuggestViewHelper',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['tx_templavoila_pi1'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Templavoila\Plugin\Pi1',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['tx_templavoila_module1'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Templavoila\Module\Module1',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\Resource\Service\FileProcessingService'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Core\Resource\Service\FileProcessingService',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Vhs\ViewHelpers\Content\Resources\FalViewHelper'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Vhs\ViewHelpers\Content\Resources\FalViewHelper',
);
$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['FluidTYPO3\Vhs\ViewHelpers\Resource\Record\FalViewHelper'] = array(
    'className' => 'IMIA\ImiaBase\Xclass\Vhs\ViewHelpers\Resource\Record\FalViewHelper',
);


if ((float)TYPO3_version >= 6.1) { // Hook (htmlTag) is not called anymore
    $GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects']['TYPO3\CMS\Core\Page\PageRenderer'] = array(
        'className' => 'IMIA\ImiaBase\Xclass\Core\Page\PageRenderer',
    );
}

require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY, 'Configuration/DevMode.php'));

if (!function_exists('user_isBackendLayout')) {
    function user_isBackendLayout($layout) {
        return \IMIA\ImiaBase\User\BackendLayout::is($layout);
    }
}

if (!class_exists('Psr\Log\LoggerInterface') && !\TYPO3\CMS\Core\Utility\GeneralUtility::_GP('install')) {
    try {
        new \TYPO3\CMS\Core\Log\Logger(null);
    } catch (\Exception $e){
        if (!function_exists('rrmdir')) {
            function rrmdir($dir) {
                if (!file_exists($dir)) {
                    return true;
                }
                if (!is_dir($dir)) {
                    return unlink($dir);
                }

                foreach (scandir($dir) as $item) {
                    if ($item != '.' && $item != '..') {
                        if (!rrmdir($dir . DIRECTORY_SEPARATOR . $item)) {
                            return false;
                        }
                    }
                }

                return rmdir($dir);
            }
        }

        @rrmdir(PATH_site . 'typo3temp/Cache/Data/cache_classes');
    }
}