<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

if (!defined('TYPO3_MODE')) {
    die('Access denied.');
}

// Page/User TS
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig(
    '<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/Configuration/BackendTS/page.ts">
    TCAdefaults.pages.lastUpdated = ' . time());

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addUserTSConfig(
    '<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/Configuration/BackendTS/user.ts">');

\IMIA\ImiaBase\Utility\ExtensionUtility::registerPageIcon($_EXTKEY, 'menu', 'Resources/Public/Images/Menu.png', 'Navigation');

\TYPO3\CMS\Core\Utility\GeneralUtility::loadTCA('sys_file_reference');
$GLOBALS['TCA']['sys_file_reference']['ctrl']['iconfile'] =
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extRelPath($_EXTKEY) . 'Resources/Public/Images/FileReference.png';

if (TYPO3_MODE == 'BE') {
    $GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['typo3/backend.php']['renderPreProcess']['tx_imiabase'] =
        'IMIA\ImiaBase\Hook\BackendController->renderPreProcess';

    $GLOBALS['TBE_STYLES']['inDocStyles_TBEstyle'] .= "\n" . file_get_contents(
            \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY) . 'Resources/Public/Stylesheets/doc.css');
}

// hide static_info_tables on root level
$GLOBALS['TCA']['static_countries']['ctrl']['hideTable'] = true;
$GLOBALS['TCA']['static_country_zones']['ctrl']['hideTable'] = true;
$GLOBALS['TCA']['static_currencies']['ctrl']['hideTable'] = true;
$GLOBALS['TCA']['static_languages']['ctrl']['hideTable'] = true;
$GLOBALS['TCA']['static_territories']['ctrl']['hideTable'] = true;

// remove the typo3 manual (unneccessary)
$helpModules = array_map('trim', explode(',', $GLOBALS['TBE_MODULES']['help']));
$helpModules = array_diff($helpModules, array('cshmanual'));
$GLOBALS['TBE_MODULES']['help'] = implode(',', $helpModules);

require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($_EXTKEY, 'Configuration/DevMode.php'));


$luceneConfiguration = &$GLOBALS['TBE_MODULES']['_configuration']['web_TwLucenesearchLucene'];
if ($luceneConfiguration) {
    $luceneConfiguration['labels'] = 'LLL:EXT:' . $_EXTKEY. '/Resources/Private/Language/ModLucene.xlf';
    $luceneConfiguration['icon'] = 'EXT:' . $_EXTKEY . '/Resources/Public/Images/Search.png';
}

$extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf'][$_EXTKEY]);
if ($extConf['bootstrapVisibility']) {
    $tempColumn = array(
        'bootstrap_visibility' => array(
            'label' => 'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/DB.xlf:content_bootstrapvisibility',
            'l10n_mode' => 'exclude',
            'config' => array(
                'items' => array(
                    array(
                        'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/DB.xlf:content_bootstrapvisibility_xs',
                        'xs',
                        'EXT:' . $_EXTKEY . '/Resources/Public/Images/Resolution/xs.png',
                    ),
                    array(
                        'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/DB.xlf:content_bootstrapvisibility_sm',
                        'sm',
                        'EXT:' . $_EXTKEY . '/Resources/Public/Images/Resolution/sm.png',
                    ),
                    array(
                        'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/DB.xlf:content_bootstrapvisibility_md',
                        'md',
                        'EXT:' . $_EXTKEY . '/Resources/Public/Images/Resolution/md.png',
                    ),
                    array(
                        'LLL:EXT:' . $_EXTKEY . '/Resources/Private/Language/DB.xlf:content_bootstrapvisibility_lg',
                        'lg',
                        'EXT:' . $_EXTKEY . '/Resources/Public/Images/Resolution/lg.png',
                    ),
                ),
                'renderMode' => 'checkbox',
                'maxitems' => '9999',
                'minitems' => '0',
                'type' => 'select',
            ),
        ),
    );
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTCAcolumns('tt_content', $tempColumn, 1);
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('tt_content', 'bootstrap_visibility', '', 'after:section_frame');
}

\IMIA\ImiaBase\Utility\ExtensionUtility::addDisplayCond('tt_content', 'tx_fed_fcefile', 'FIELD:CType:=:fluidcontent_content');